package be.iminds.ilabt.jfed.experimenter_gui.preferences.subsections;

import be.iminds.ilabt.jfed.experimenter_gui.preferences.AbstractPreferencesSubPane;
import be.iminds.ilabt.jfed.gui_preferences.HLPreferenceKey;
import be.iminds.ilabt.jfed.gui_preferences.JFedHLPreferences;
import be.iminds.ilabt.jfed.util.common.OSDetector;
import javafx.fxml.FXML;
import javafx.scene.Node;
import javafx.scene.control.Label;
import javafx.scene.control.TextArea;
import javafx.scene.layout.BorderPane;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.inject.Inject;

/**
 * TerminalCommandPanel
 */
public class RDPPane extends AbstractPreferencesSubPane {
    private final static Logger LOG = LoggerFactory.getLogger(RDPPane.class);

    @FXML protected TextArea rdpCommandTextArea;
    @FXML private Label rdpCommandLabel;
    @FXML
    private BorderPane root;

    private final JFedHLPreferences jFedPreferences;

    @Override
    public Node getRoot() {
        return root;
    }

    @Inject
    RDPPane(JFedHLPreferences jFedPreferences) {
        super("Windows Remote Desktop", false);
        this.jFedPreferences = jFedPreferences;
    }

    @FXML
    private void initialize() {
        if (OSDetector.findOS() == OSDetector.OS.MAC) {
//            rdpCommandLabel.setText("AppleScript commands:");
        }


        if (jFedPreferences.getString(HLPreferenceKey.PREF_COMMAND_RDP) != null)
            rdpCommandTextArea.setText(jFedPreferences.getString(HLPreferenceKey.PREF_COMMAND_RDP));
    }

    @Override
    public boolean check() {
//        if (!rdpCommandTextArea.getText().contains("%h")) {
//            JFDialogs.create()
//                    .owner(root)
//                    .message("Your terminal command must contain '%h'")
//                    .showError();
//            return false;
//        }
//        if (!rdpCommandTextArea.getText().contains("%p")) {
//            JFDialogs.create()
//                    .owner(root)
//                    .message("Your terminal command must contain '%p'")
//                    .showError();
//            return false;
//        }

        return true;
    }
    @Override
    public boolean save() {
        jFedPreferences.setString(HLPreferenceKey.PREF_COMMAND_RDP, rdpCommandTextArea.getText());

        return true;
    }
}
