package be.iminds.ilabt.jfed.lowlevel.api_wrapper.impl;

import be.iminds.ilabt.jfed.fedmon.webapi.service.json.Server;
import be.iminds.ilabt.jfed.log.Logger;
import be.iminds.ilabt.jfed.lowlevel.api.AggregateManager3;
import be.iminds.ilabt.jfed.lowlevel.api.user_spec.UserSpec;
import be.iminds.ilabt.jfed.lowlevel.api_wrapper.AggregateManagerWrapper;
import be.iminds.ilabt.jfed.lowlevel.api_wrapper.StatusDetails;
import be.iminds.ilabt.jfed.lowlevel.connection.JFedException;
import be.iminds.ilabt.jfed.lowlevel.connection_pool.JFedConnectionProvider;
import be.iminds.ilabt.jfed.lowlevel.credential.AnyCredential;
import be.iminds.ilabt.jfed.lowlevel.user.GeniUserProvider;
import be.iminds.ilabt.jfed.preferences.JFedPreferences;
import be.iminds.ilabt.jfed.util.common.GeniUrn;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.Date;
import java.util.List;
import java.util.Map;

public class FakeEdgeAMWrapper extends AggregateManagerWrapper {
    protected FakeEdgeAMWrapper(@NotNull Logger logger, @NotNull GeniUserProvider geniUserProvider, @NotNull JFedConnectionProvider connectionProvider, @NotNull JFedPreferences jFedPreferences, @NotNull Server amServer) {
        super(logger, geniUserProvider, connectionProvider, jFedPreferences, amServer);
    }

    @Override
    public Map getVersion() throws JFedException {
        throw new RuntimeException("Not implemented by AM (because there is no AM, this is a fake edge VLAN)");
    }

    @Override
    public String listResources(@NotNull List<AnyCredential> userCredentials, boolean available, @NotNull String type, @NotNull String version) throws JFedException {
        throw new RuntimeException("Not implemented by AM (because there is no AM, this is a fake edge VLAN)");
    }

    @Override
    public String createSliver(@NotNull GeniUrn sliceUrn, @NotNull List<AnyCredential> sliceCredentials, @NotNull String rspec, @Nullable List<UserSpec> userSpecs, @Nullable Date expirationDate) throws JFedException {
        throw new RuntimeException("Not implemented by AM (because there is no AM, this is a fake edge VLAN)");
    }

    @Override
    public boolean hasSeperateAllocateAndProvision() {
        return false;
    }

    @Override
    public AllocateReply allocate(@NotNull GeniUrn sliceUrn, @NotNull List<AnyCredential> sliceCredentials, @NotNull String rspec, @Nullable Date expirationDate) throws JFedException {
        throw new RuntimeException("Not implemented by AM (because there is no AM, this is a fake edge VLAN)");
    }

    @Override
    public AllocateReply allocate(@NotNull GeniUrn sliceUrn, @NotNull List<AnyCredential> sliceCredentials, @NotNull String rspec, Date startDate, Date endDate) throws JFedException {
        throw new RuntimeException("Not implemented by AM (because there is no AM, this is a fake edge VLAN)");
    }

    @Override
    public String provisionAndStart(@NotNull GeniUrn sliceUrn, @NotNull List<AnyCredential> sliceCredentials, @Nullable List<UserSpec> userSpecs, @Nullable Date expirationDate) throws JFedException {
        throw new RuntimeException("Not implemented by AM (because there is no AM, this is a fake edge VLAN)");
    }

    @Override
    public ProvisionReply provision(@NotNull GeniUrn sliceUrn, @NotNull List<AnyCredential> sliceCredentials, @Nullable List<UserSpec> userSpecs, @Nullable Date expirationDate) throws JFedException {
        throw new RuntimeException("Not implemented by AM (because there is no AM, this is a fake edge VLAN)");
    }

    @Override
    public void poaStart(@NotNull GeniUrn sliceUrn, @NotNull List<AnyCredential> sliceCredentials) throws JFedException {
        throw new RuntimeException("Not implemented by AM (because there is no AM, this is a fake edge VLAN)");
    }

    @Override
    public void deleteSliver(@NotNull GeniUrn sliceUrn, @NotNull List<AnyCredential> sliceCredentials) throws JFedException {
        throw new RuntimeException("Not implemented by AM (because there is no AM, this is a fake edge VLAN)");
    }

    @Nullable
    @Override
    public StatusDetails status(@NotNull GeniUrn urn, @NotNull List<AnyCredential> sliceCredentials) throws JFedException {
        throw new RuntimeException("Not implemented by AM (because there is no AM, this is a fake edge VLAN)");
    }

    @Nullable
    @Override
    public AggregateManager3.StatusInfo status_v3(@NotNull GeniUrn urn, @NotNull List<AnyCredential> sliceCredentials) throws JFedException {
        throw new RuntimeException("Not implemented by AM (because there is no AM, this is a fake edge VLAN)");
    }

    @Override
    public String describe(@NotNull GeniUrn urn, @NotNull List<AnyCredential> sliceCredentials) throws JFedException {
        throw new RuntimeException("Not implemented by AM (because there is no AM, this is a fake edge VLAN)");
    }

    @Override
    public List<GeniUrn> renewSlivers(@Nullable GeniUrn sliceUrn, @Nullable List<GeniUrn> slivers, @NotNull List<AnyCredential> sliceCredentials, @NotNull Date newExpire) throws JFedException {
        throw new RuntimeException("Not implemented by AM (because there is no AM, this is a fake edge VLAN)");
    }

    @Override
    public boolean isExirationdateSetByCreateSliver() {
        return false;
    }

    @Override
    public boolean isShareLanSupported() {
        return false;
    }

    @Override
    public boolean isRestartSupported() {
        return false;
    }

    @Override
    public boolean isReloadOSSupported() {
        return false;
    }

    @Override
    public boolean isOpenConsoleSupported() {
        return false;
    }

    @Override
    public boolean isEditSshKeysSupported() {
        return false;
    }
}
